(*************************************************************************
 *                                                                       *
 *                            ISDN fr Delphi                            *
 *                                                                       *
 *                       EuroFileTransfer-Addon                          *
 *                                                                       *
 *                             Version 1.25                              *
 *                                                                       *
 *************************************************************************
 *                    Copyright (c) Stefan Graf 2000                     *
 *                         All rights reserved.                          *
 *************************************************************************
 *                            info@isdn-tools.de                         *
 *                         http://www.isdn-tools.de                      *
 *************************************************************************
 * $Revision: 1.4 $
 * $Date: 2000-10-11 12:20:53+02 $
 *************************************************************************)
unit EFTMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Capi2Bas, Capi2han, Capi2Typ, Capi2Con, CapiProt, EFTProtokoll, StdCtrls,
  Menus, EFTUsers, Grids, DirList, ComCtrls, IniFiles;

type
  TConfigDaten = record
    MSN     : TCallNumber;
    AppName : String [32];
  end;

  TForm1 = class(TForm)
    Capi20Handler1: TCapi20Handler;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    EFTProtokoll1: TEFTProtokoll;
    Memo2: TMemo;
    Button3: TButton;
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    Setup1: TMenuItem;
    User1: TMenuItem;
    Button4: TButton;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    PopupMenu1: TPopupMenu;
    Kopieren1: TMenuItem;
    N1: TMenuItem;
    Sort1: TMenuItem;
    Name1: TMenuItem;
    Size1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    PopupMenu2: TPopupMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    StatusBar1: TStatusBar;
    LocalDirName: TLabel;
    RemoteDirName: TLabel;
    Konfiguration1: TMenuItem;
    N2: TMenuItem;
    Lschen1: TMenuItem;
    Date1: TMenuItem;
    AllesEmpfangen1: TMenuItem;
    AllesKopieren1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Capi20Handler1MessageDump(Sender: TObject; const CommandID,
      SubCommand: Cardinal; var Daten: ReceiveDatenType);
    function Capi20Handler1Ring(Sender: TObject;
      const CallDaten: TCallDaten): Cardinal;
    function EFTProtokoll1ReqConnect(Sender: TObject; const Name, Passwd : String): Boolean;
    procedure Button3Click(Sender: TObject);
    procedure User1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure EFTProtokoll1FileReceived(Sender: TObject; const Result : Integer);
    function EFTProtokoll1GetFile(Sender: TObject;
      const FileName: TFileName): TFileName;
    procedure EFTProtokoll1BlockReceived(Sender: TObject);
    procedure CallEFTServer(Sender: TObject);
    procedure EFTProtokoll1Disconnect(Sender: TObject);
    procedure EFTProtokoll1Connect(Sender: TObject);
    procedure EFTProtokoll1DirReceived(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StringGrid2Click(Sender: TObject);
    procedure SortbyName2Click(Sender: TObject);
    procedure SortbyTime2Click(Sender: TObject);
    procedure SortbySize2Click(Sender: TObject);
    procedure SortbyName1Click(Sender: TObject);
    procedure SortbySize1Click(Sender: TObject);
    procedure Empfangen(Sender: TObject);
    procedure StringGrid2KeyPress(Sender: TObject; var Key: Char);
    procedure EFTProtokoll1FileSend(Sender: TObject; const Result : Integer);
    function EFTProtokoll1PutFile(Sender: TObject; const FileName: TFileName): TFileName;
    procedure Konfiguration1Click(Sender: TObject);
    procedure Kopieren1Click(Sender: TObject);
    procedure EFTProtokoll1TransferAbort(Sender: TObject; const Grund : Cardinal);
    procedure Capi20Handler1Connect(Sender: TObject);
    procedure Capi20Handler1Disconnect(Sender: TObject;
      const Grund: Cardinal);
    procedure Lschen1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure StringGrid1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure StringGrid1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Date1Click(Sender: TObject);
    procedure AllesEmpfangen1Click(Sender: TObject);
    procedure AllesKopieren1Click(Sender: TObject);
  private
    TransferStartTime : DWORD;
    LocalDirList : TDirList;
    ConfigDaten : TConfigDaten;
    RecvIndex   : Integer;
    RecvListe   : TStringList;
    SendIndex   : Integer;
    SendListe   : TStringList;

    procedure DisplayDirectoryList (StringGrid : TStringGrid; DirList : TDirList);
    procedure DisplayDirectory (const DirName : TFileName);

    function SaveConfiguration (const FileName : TFileName) : Integer;
    function LoadConfiguration (const FileName : TFileName) : Integer;

    procedure AbortTransfer (Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses EFTTransfer, EFTCallDaten, EFTSetup;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Button4.Enabled := false;
  Button1.Enabled := false;
  Button2.Enabled := true;

  StringGrid2.Enabled := false;
  StringGrid2.Color := clBtnFace;
  StringGrid2.RowCount := StringGrid2.FixedRows + 1;
  StringGrid2.Cells [0, 1] := '';
  StringGrid2.Cells [1, 1] := '';

  LocalDirName.Caption := '';

  Capi20Handler1.EnableListen ([DATA_64k]);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Capi20Handler1.EnableListen ([]);

  Button2.Enabled := false;
  Button1.Enabled := true;
  Button4.Enabled := true;
  StringGrid2.Enabled := true;
  StringGrid2.Color := clWindow;
  StringGrid2.Refresh;

  DisplayDirectory ('*.*');
end;

procedure TForm1.Capi20Handler1MessageDump(Sender: TObject; const CommandID, SubCommand: Cardinal; var Daten: ReceiveDatenType);
begin
  if (CommandID <> DATA_B3) then
    Memo1.Lines.Add (Capi20Handler1.GetCommandStr (CommandID, SubCommand));
end;

function TForm1.Capi20Handler1Ring(Sender: TObject; const CallDaten: TCallDaten): Cardinal;
var
  line : String;
  tonumstr,
  fromnumstr : String;

begin
  with CallDaten do begin
    tonumstr := Copy (CallTo,2,255);
    fromnumstr := Copy (CallFrom,3,255);

    line := 'Call from ' + fromnumstr + '(' + SubFrom + ')' + ' to ' + tonumstr;
    line := line + ' : Service : ' + IntToStr (Ord (Service));
  end;

  Memo1.Lines.Add (line);

  if (tonumstr = ConfigDaten.MSN) then
    Result := ACCEPT_CALL
  else Result := IGNORE_CALL;
end;

function TForm1.EFTProtokoll1ReqConnect(Sender: TObject; const Name, Passwd : String): Boolean;
var
  idx   : Integer;
  found : Boolean;
  userdaten : TUserDaten;
begin
  Memo2.Lines.Add (EFTProtokoll1.RemoteAddress);
  Memo2.Lines.Add (Name);
  Memo2.Lines.Add (Passwd);

  idx := 0;
  found := false;

  while not (found) and (idx < EFTUserSetup.UserAnzahl) do begin
    userdaten := EFTUserSetup.User [idx];

    if (userdaten.UserName = Name) then
      found := true
    else Inc (idx);
  end;

  if (found) then begin
    EFTProtokoll1.BaseDirectory := userdaten.StartDir;
    EFTProtokoll1ReqConnect := true;
  end else begin
    EFTProtokoll1ReqConnect := false;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  EFTProtokoll1.SessionEnd;
end;

procedure TForm1.User1Click(Sender: TObject);
begin
  EFTUserSetup.Top := Top + 20;
  EFTUserSetup.Left := Left + 20;
  EFTUserSetup.EditUserList;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.EFTProtokoll1FileReceived(Sender: TObject; const Result : Integer);
begin
  if (Result = 0) then begin
    TransferStartTime := GetTickCount - TransferStartTime;
    Memo2.Lines.Add ('Datei empfangen; Dauer : ' + InttoStr (TransferStartTime div 1000) + ' Sek.');
  end else begin
    Memo2.Lines.Add ('Fehler ' + IntToStr (Result) + ' beim Empfangen');

    if (EFTProtokoll1.EFTMode = Master) then
      MessageDLG ('Fehler ' + IntToStr (Result) + ' beim Empfangen', mtError, [mbOK], 0);
  end;

  if (RecvIndex < SendListe.Count) then begin
    EFTProtokoll1.RequestFile (RecvListe.Strings [SendIndex]);

    Inc (RecvIndex);
  end else begin
    FormShowTransfer.Visible := false;
    DisplayDirectory ('*.*');
  end;
end;

function TForm1.EFTProtokoll1GetFile(Sender: TObject; const FileName: TFileName): TFileName;
begin
  FormShowTransfer.AbortTransfer := AbortTransfer;

  FormShowTransfer.Caption := 'Empfangen ...';
  FormShowTransfer.ProgressBar1.Position := 0;
  FormShowTransfer.NameLabel.Caption := FileName;
  FormShowTransfer.SizeLabel.Caption := '';
  FormShowTransfer.Visible := true;

  TransferStartTime := GetTickCount;

  EFTProtokoll1GetFile := FileName;
end;

procedure TForm1.EFTProtokoll1BlockReceived(Sender: TObject);
begin
  with (EFTProtokoll1 as TEFTProtokoll) do begin
    if (TransferMode = Receive) then begin
      if (Length (FormShowTransfer.SizeLabel.Caption) = 0) then begin
        FormShowTransfer.SizeLabel.Caption := IntToStr (RecvFileSize);
        FormShowTransfer.ProgressBar1.Max := RecvFileSize;
      end;

      FormShowTransfer.ProgressBar1.Position := RecvFileProgress;
    end else begin
      if (Length (FormShowTransfer.SizeLabel.Caption) = 0) then begin
        FormShowTransfer.SizeLabel.Caption := IntToStr (SendFileSize);
        FormShowTransfer.ProgressBar1.Max := SendFileSize;
      end;

      FormShowTransfer.ProgressBar1.Position := SendFileProgress;
    end;
  end;
end;

procedure TForm1.CallEFTServer(Sender: TObject);
var
  i       : Integer;
  inifile : TIniFile;
  line    : string;
begin
  inifile := TIniFile.Create (ExtractFilePath (ParamStr (0)) + 'eftcall.ini');

  FormCallData.Edit1.Text := inifile.ReadString ('LastCall','Number','');
  FormCallData.Edit2.Text := inifile.ReadString ('LastCall','User','');

  line := inifile.ReadString ('LastCall','Passwd','');

  for i:=1 to Length (line) do
    line [i] := char (ord (line [i]) xor $23 xor i);

  FormCallData.Edit3.Text := line;

  if (FormCallData.ShowModal = mrOk) then begin
    inifile.WriteString ('LastCall','Number',FormCallData.Edit1.Text);
    inifile.WriteString ('LastCall','User',FormCallData.Edit2.Text);

    line := FormCallData.Edit3.Text;

    for i:=1 to Length (line) do
      line [i] := char (ord (line [i]) xor $23 xor i);

    inifile.WriteString ('LastCall','Passwd',line);
    inifile.Updatefile;

    EFTProtokoll1.UserName := FormCallData.Edit2.Text;
    EFTProtokoll1.Password := FormCallData.Edit3.Text;

    if (Capi20Handler1.Call (FormCallData.Edit1.Text,'',DATA_64K)) then
      Button3.Enabled := true
    else MessageDLG ('Fehler beim Anwhlen von ' + FormCallData.Edit1.Text, mtError, [mbOK], 0);
  end;

  inifile.Free;
end;

procedure TForm1.EFTProtokoll1Disconnect(Sender: TObject);
begin
  Capi20Handler1.DisconnectLine (0);

  StringGrid1.Enabled := false;
  StringGrid1.Color := clBtnFace;
  StringGrid1.RowCount := StringGrid1.FixedRows + 1;
  StringGrid1.Cells [0, 1] := '';
  StringGrid1.Cells [1, 1] := '';

  RemoteDirName.Caption := '';
end;

procedure TForm1.EFTProtokoll1Connect(Sender: TObject);
begin
  if (EFTProtokoll1.EFTMode = Master) then begin
    EFTProtokoll1.DirList.SortBy := s_Name;
    EFTProtokoll1.RequestDirectory ('*');
    StringGrid1.Enabled := true;
    StringGrid1.Color := clWindow;
  end else begin
    Memo2.Lines.Add (EFTProtokoll1.RemoteAddress);
    Memo2.Lines.Add (EFTProtokoll1.CallUserName);
    Memo2.Lines.Add (EFTProtokoll1.CallPassword);

    EFTProtokoll1.RequestDirectory ('*');
  end;
end;

procedure TForm1.EFTProtokoll1DirReceived(Sender: TObject);
var
  i       : Integer;
  dirname : TDirName;
begin
  if (EFTProtokoll1.EFTMode = Slave) then begin
     RecvListe.Clear;
     RecvIndex := 0;

     if (EFTProtokoll1.DirList.Count > 0) then begin
        for i:= 0 to EFTProtokoll1.DirList.Count - 1 do begin
          RecvListe.Add (EFTProtokoll1.DirList.Items [i].Name);
        end;
     end;

     if (RecvIndex < RecvListe.Count) then begin
       EFTProtokoll1.ReceiveDirectory := LocalDirList.DirName;
       EFTProtokoll1.RequestFile (RecvListe.Strings [RecvIndex]);

       Inc (RecvIndex);
     end;
  end else begin
    dirname := EFTProtokoll1.RemoteDirectory;
    if (Length (dirname) > 20) then
      dirname := '..' + Copy (dirname, Length (dirname) - 20, 20);
    LocalDirName.Caption := dirname;

    if (StringGrid1.FixedRows > 0) then begin
      StringGrid1.Cells [0, 0] := 'Dateiname';
      StringGrid1.Cells [1, 0] := 'Grsse';
      StringGrid1.Cells [2, 0] := 'Datum';
    end;

    with EFTProtokoll1 do begin
      StringGrid1.RowCount := StringGrid1.FixedRows + DirList.Count;

      if (DirList.Count > 0) then begin
        for i:= 0 to DirList.Count - 1 do begin
          with DirList.Items [i] do begin
            StringGrid1.Cells [0, StringGrid1.FixedRows + i] := Name;

            if ((Attr and faDirectory) <> 0) then
              StringGrid1.Cells [1, StringGrid1.FixedRows + i] := 'DIR'
            else begin
              StringGrid1.Cells [1, StringGrid1.FixedRows + i] := IntToStr (Size);

              if (DirList.Items [i].Time = 0) then
                StringGrid1.Cells [2, StringGrid1.FixedRows + i] := ''
              else StringGrid1.Cells [2, StringGrid1.FixedRows + i] := DateTimeToStr (FileDateToDateTime (DirList.Items [i].Time));

            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TForm1.StringGrid1Click(Sender: TObject);
var res : Integer;
begin
  if (StringGrid1.Cells [1, StringGrid1.Row] = 'DIR') then begin
    res := EFTProtokoll1.SelectDirectory (StringGrid1.Cells [0, StringGrid1.Row]);
    if (res <> 0) then
      MessageDLG ('Fehler ' + IntToStr (res) + ' beim wechseln des Verzeichnisses', mtWarning, [mbOK], 0)
    else EFTProtokoll1.RequestDirectory ('*');
  end else begin
    EFTProtokoll1.RequestFile (StringGrid1.Cells [0, StringGrid1.Row]);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LocalDirList := TDirList.Create;
  SendListe := TStringList.Create;
  RecvListe := TStringList.Create;

  FillChar (ConfigDaten, sizeof (ConfigDaten), 0);
  LoadConfiguration ('efttest.dat');

  DisplayDirectory ('*.*');
end;

procedure TForm1.DisplayDirectoryList (StringGrid : TStringGrid; DirList : TDirList);
var
  i       : Integer;
  dirname : TDirName;
begin
  if (IOResult = 0) Then begin
    dirname := DirList.DirName;
    if (Length (dirname) > 20) then
      dirname := '..' + Copy (dirname, Length (dirname) - 20, 20);

    if (DirList = LocalDirList) then
      LocalDirName.Caption := dirname
    else RemoteDirName.Caption := dirname;
  end;

  if (StringGrid.FixedRows > 0) then begin
    StringGrid.Cells [0, 0] := 'Dateiname';
    StringGrid.Cells [1, 0] := 'Grsse';
    StringGrid.Cells [2, 0] := 'Datum';
  end;

  if (DirList.Count > 0) then begin
    for i:=0 to DirList.Count - 1 do begin
      StringGrid.Cells [0, StringGrid.FixedRows + i] := DirList.Items [i].Name;

      if ((DirList.Items [i].Attr and faDirectory) <> 0) then begin
        StringGrid.Cells [1, StringGrid.FixedRows + i] := 'DIR';
      end else begin
        StringGrid.Cells [1, StringGrid.FixedRows + i] := IntToStr (DirList.Items [i].Size);

        if (DirList.Items [i].Time = 0) then
          StringGrid.Cells [2, StringGrid.FixedRows + i] := ''
        else StringGrid.Cells [2, StringGrid.FixedRows + i] := DateTimeToStr (FileDateToDateTime (DirList.Items [i].Time));
      end;
    end;
  end;
end;

procedure TForm1.DisplayDirectory (const DirName : TFileName);
var
  dirinfo     : TSearchRec;
  res         : Integer;
  direntry    : TDirListEntry;
  namestr     : TDirName;
  Save_Cursor : TCursor;
begin
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;    { Cursor als Sanduhr }

  try
    GetDir (0, namestr);

    LocalDirList.Clear;
    LocalDirList.DirName := namestr;
    LocalDirList.SortBy  := s_Name;

    if (FindFirst (DirName,faDirectory + faReadOnly + faArchive, dirinfo) = 0) then begin
      repeat
        direntry.Name := dirinfo.Name;
        direntry.Time := dirinfo.Time;
        direntry.Attr := dirinfo.Attr;

        if ((dirinfo.Attr and faDirectory) <> 0) then
          direntry.Size := -1
        else direntry.Size := dirinfo.Size;

        LocalDirList.Add (direntry);

        res := FindNext (dirinfo)
      until (res <> 0);
    end;

    StringGrid2.RowCount := StringGrid2.FixedRows + LocalDirList.Count;

    DisplayDirectoryList (StringGrid2, LocalDirList);

  finally
    Screen.Cursor := Save_Cursor;

  end;

end;

procedure TForm1.StringGrid2Click(Sender: TObject);
begin
  if (StringGrid2.Cells [1, StringGrid2.Row] = 'DIR') then begin
    ChDir (StringGrid2.Cells [0, StringGrid2.Row]);
    if (IOResult = 0) Then
      DisplayDirectory ('*.*');
  end;
end;

procedure TForm1.SortbyName2Click(Sender: TObject);
begin
  LocalDirList.SortBy := s_Name;
  LocalDirList.Sort;
  DisplayDirectoryList (StringGrid2, LocalDirList);
end;

procedure TForm1.SortbyTime2Click(Sender: TObject);
begin
  LocalDirList.SortBy := Time;
  LocalDirList.Sort;
  DisplayDirectoryList (StringGrid2, LocalDirList);
end;

procedure TForm1.SortbySize2Click(Sender: TObject);
begin
  LocalDirList.SortBy := Size;
  LocalDirList.Sort;
  DisplayDirectoryList (StringGrid2, LocalDirList);
end;

procedure TForm1.SortbyName1Click(Sender: TObject);
begin
  EFTProtokoll1.DirList.SortBy := s_Name;
  EFTProtokoll1.DirList.Sort;
  DisplayDirectoryList (StringGrid1, EFTProtokoll1.DirList);
end;

procedure TForm1.SortbySize1Click(Sender: TObject);
begin
  EFTProtokoll1.DirList.SortBy := Size;
  EFTProtokoll1.DirList.Sort;
  DisplayDirectoryList (StringGrid1, EFTProtokoll1.DirList);
end;


procedure TForm1.Empfangen(Sender: TObject);
var
  fname : TFileName;
  res : Integer;
begin
  fname := StringGrid2.Cells [0, StringGrid2.Row];

  res := EFTProtokoll1.SendingFile (fname);

  if (res <> 0) then
    MessageDLG ('Fehler ' + IntToStr (res) + ' beim Senden von ' + fname, mtWarning, [mbOK], 0);
end;

procedure TForm1.StringGrid2KeyPress(Sender: TObject; var Key: Char);
begin
  if (Sender is TStringGrid) then begin
    with (Sender as TStringGrid) do begin
      if (Key = #13) then begin
        if (Cells [1, Row] = 'DIR') then begin
          ChDir (Cells [0, Row]);
          if (IOResult = 0) then
            DisplayDirectory ('*.*');
        end;
      end;
    end;
  end;
end;

procedure TForm1.EFTProtokoll1FileSend(Sender: TObject; const Result : Integer);
var res : Integer;
begin
  if (Result = 0) then begin
    TransferStartTime := GetTickCount - TransferStartTime;
    Memo2.Lines.Add ('Datei gesendet; Dauer : ' + InttoStr (TransferStartTime div 1000) + ' Sek.');
  end else begin
    Memo2.Lines.Add ('Fehler ' + IntToStr (Result) + ' beim Senden');

    if (EFTProtokoll1.EFTMode = Master) then
      MessageDLG ('Fehler ' + IntToStr (Result) + ' beim Senden', mtError, [mbOK], 0);
  end;

  if (SendIndex < SendListe.Count) then begin
    res := EFTProtokoll1.SendingFile (SendListe.Strings [SendIndex]);

    if (res = 0) then
      Inc (SendIndex)
    else begin
      Memo2.Lines.Add ('Fehler ' + IntToStr (res) + ' beim Senden von ' + SendListe.Strings [SendIndex]);

      FormShowTransfer.Visible := false;

      if (EFTProtokoll1.EFTMode = Master) then
        EFTProtokoll1.RequestDirectory ('*');
    end;
  end else begin
    FormShowTransfer.Visible := false;

    if (EFTProtokoll1.EFTMode = Master) then
      EFTProtokoll1.RequestDirectory ('*');
  end;
end;

function TForm1.EFTProtokoll1PutFile(Sender: TObject; const FileName: TFileName): TFileName;
begin
  FormShowTransfer.AbortTransfer := AbortTransfer;

  FormShowTransfer.Caption := 'Senden ...';
  FormShowTransfer.ProgressBar1.Position := 0;
  FormShowTransfer.NameLabel.Caption := FileName;
  FormShowTransfer.SizeLabel.Caption := '';
  FormShowTransfer.Visible := true;

  TransferStartTime := GetTickCount;

  EFTProtokoll1PutFile := FileName;
end;

procedure TForm1.Konfiguration1Click(Sender: TObject);
begin
  EFTSetupForm.Top := Top + 30;
  EFTSetupForm.Left := Left + 30;
  
  EFTSetupForm.Edit1.Text := ConfigDaten.MSN;
  EFTSetupForm.Edit2.Text := ConfigDaten.AppName;

  if (EFTSetupForm.ShowModal = mrOk) Then begin
    ConfigDaten.MSN     := EFTSetupForm.Edit1.Text;
    ConfigDaten.AppName := EFTSetupForm.Edit2.Text;

    SaveConfiguration ('efttest.dat');
  end;
end;

function TForm1.SaveConfiguration (const FileName : TFileName) : Integer;
var filevar : File;
begin
  AssignFile (filevar, FileName);
  Rewrite (filevar, 1);
  if (IOResult <> 0) then
    SaveConfiguration := -1
  else begin
    BlockWrite (filevar, ConfigDaten, sizeof (ConfigDaten));

    CloseFile (filevar);

    SaveConfiguration := 0;
  end;
end;

function TForm1.LoadConfiguration (const FileName : TFileName) : Integer;
var
  readanz : Integer;
  filevar : File;
begin
  AssignFile (filevar, FileName);
  Reset (filevar, 1);
  if (IOResult <> 0) then
    LoadConfiguration := -1
  else begin
    BlockRead (filevar, ConfigDaten, sizeof (ConfigDaten), readanz);

    CloseFile (filevar);

    LoadConfiguration := 0;
  end;
end;

procedure TForm1.Kopieren1Click(Sender: TObject);
var
  res : Integer;
  fname : TFileName;
begin
  if (StringGrid1.Cells [1, StringGrid1.Row] <> 'DIR') then begin
    fname := StringGrid1.Cells [0, StringGrid1.Row];

    EFTProtokoll1.ReceiveDirectory := LocalDirList.DirName;
    res := EFTProtokoll1.RequestFile (fname);

    if (res <> 0) then
      MessageDLG ('Fehler ' + IntToStr (res) + ' beim Empfangen von ' + fname, mtWarning, [mbOK], 0);
  end;
end;

procedure TForm1.EFTProtokoll1TransferAbort(Sender: TObject; const Grund : Cardinal);
begin
  FormShowTransfer.Visible := false;
  Memo2.Lines.Add ('Transfer abgebrochen');
end;

procedure TForm1.Capi20Handler1Connect(Sender: TObject);
begin
  Button3.Enabled := true;
end;

procedure TForm1.Capi20Handler1Disconnect(Sender: TObject;
  const Grund: Cardinal);
begin
  Button3.Enabled := false;
end;

procedure TForm1.Lschen1Click(Sender: TObject);
var
  res : Integer;
  fname : TFileName;
begin
  if (StringGrid1.Cells [1, StringGrid1.Row] <> 'DIR') then begin
    fname := StringGrid1.Cells [0, StringGrid1.Row];

    res := EFTProtokoll1.DeleteFile (fname);

    if (res <> 0) then
      MessageDLG ('Fehler ' + IntToStr (res) + ' beim Lschen von ' + fname, mtWarning, [mbOK], 0);
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  EFTProtokoll1.SelectDirectory ('xyz');
  EFTProtokoll1.GetFileStore;
end;

procedure TForm1.StringGrid1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if (Sender = StringGrid2) and (Source is TStrings) then
    Accept := true;
end;

procedure TForm1.StringGrid1DragDrop(Sender, Source: TObject; X, Y: Integer);
var
  res   : Integer;
  fname : TFilename;
begin
  with (Source as TStrings) do begin
    fname := Strings [0];

    if (Length (fname) > 0) then begin
      res := EFTProtokoll1.SendingFile (fname);

      if (res <> 0) then
        MessageDLG ('Fehler ' + IntToStr (res) + ' beim Senden von ' + fname, mtWarning, [mbOK], 0);
    end;
  end;
end;

procedure TForm1.Date1Click(Sender: TObject);
begin
  EFTProtokoll1.DirList.SortBy := Time;
  EFTProtokoll1.DirList.Sort;
  DisplayDirectoryList (StringGrid1, EFTProtokoll1.DirList);
end;

procedure TForm1.AllesEmpfangen1Click(Sender: TObject);
var i : Integer;
begin
  RecvIndex := 0;
  RecvListe.Clear;

  for i:=1 to (StringGrid1.RowCount - 1) do begin
    if (StringGrid1.Cells [1, i] <> 'DIR') then begin
      RecvListe.Add (StringGrid1.Cells [0, i]);
    end;
  end;

  if (RecvIndex < RecvListe.Count) then begin
    EFTProtokoll1.ReceiveDirectory := LocalDirList.DirName;
    EFTProtokoll1.RequestFile (RecvListe.Strings [RecvIndex]);

    Inc (RecvIndex);
  end;
end;

procedure TForm1.AllesKopieren1Click(Sender: TObject);
var i : Integer;
begin
  SendIndex := 0;
  SendListe.Clear;

  for i:=1 to (StringGrid2.RowCount - 1) do begin
    if (StringGrid2.Cells [1, i] <> 'DIR') then begin
      SendListe.Add (StringGrid2.Cells [0, i]);
    end;
  end;

  if (SendIndex < SendListe.Count) then begin
    EFTProtokoll1.SendingFile (SendListe.Strings [SendIndex]);

    Inc (SendIndex);
  end;
end;

procedure TForm1.AbortTransfer (Sender: TObject);
begin
  EFTProtokoll1.AbortTransfer (EFT_USER_ABORT);
end;

end.
