{$I-}
(*************************************************************************
 *                                                                       *
 *                            ISDN fr Delphi                            *
 *                                                                       *
 *                       EuroFileTransfer-Addon                          *
 *                                                                       *
 *                             Version 1.00                              *
 *                                                                       *
 *************************************************************************
 *                    Copyright (c) Stefan Graf 1999                     *
 *                         All rights reserved.                          *
 *************************************************************************
 *                            info@isdn-tools.de                         *
 *                         http://www.isdn-tools.de                      *
 *************************************************************************
 * $Revision: 1.1 $
 * $Date: 2000-08-26 16:06:37+02 $
 *************************************************************************)
unit EFTUsers;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls;

type
  PUserDaten = ^TUserDaten;
  TUserDaten = record
    UserName : String [32];
    Password : String [32];
    RealName : String [32];
    StartDir : String [255];
  end;

  TEFTUserSetup = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    NeuerUser1: TMenuItem;
    Edit4: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure NeuerUser1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    function GetUserAnzahl : Integer;
    function GetUser (Index: Integer) : TUserDaten;
  private
    AktIndex : Integer;
    AktUser  : TUserDaten;
    UserListe : TList;

    procedure UpdateListbox;
    procedure DisplayAktUser;
  public
    constructor Create (AOwner: TComponent); override;
    destructor  Destroy; override;

    procedure   Loaded; override;

    function    EditUserList: Integer;

    property UserAnzahl : Integer read GetUserAnzahl;
    property User [Index : Integer] : TUserDaten read GetUser;
  end;

var
  EFTUserSetup: TEFTUserSetup;

implementation

//uses FileUtils;
uses FileCtrl;
{$R *.DFM}


constructor TEFTUserSetup.Create (AOwner: TComponent);
begin
  UserListe := TList.Create;

  inherited Create (AOwner);
end;

destructor TEFTUserSetup.Destroy;
begin
  if (UserListe <> Nil) then
    UserListe.Destroy;

  inherited;
end;

procedure TEFTUserSetup.Loaded;
var
  filevar : File;
  idx     : Integer;
  data    : PUserDaten;
begin
  inherited Loaded;

  UserListe.Clear;

  AssignFile (filevar,ExtractFilePath (ParamStr (0)) + 'eftusers.dat');
  Reset (filevar, 1);
  if (IOResult = 0) then begin
    idx := 0;
    while not (eof (filevar)) do begin
      New (data);
      BlockRead (filevar, data^, sizeof (TUserDaten));
      UserListe.Insert (idx, data);
      Inc (idx);
    end;

    CloseFile (filevar);
  end;
end;

function TEFTUserSetup.GetUserAnzahl : Integer;
begin
  GetUserAnzahl := UserListe.Count;
end;

function TEFTUserSetup.GetUser (Index: Integer) : TUserDaten;
begin
  GetUser := TUserDaten (UserListe.Items[Index]^);
end;

procedure TEFTUserSetup.DisplayAktUser;
begin
  if (AktIndex = -1) then begin
    Edit1.Enabled := false;
    Edit1.Color   := clBtnFace;
    Edit1.Text    := '';
    Edit2.Enabled := false;
    Edit2.Color   := clBtnFace;
    Edit2.Text    := '';
    Edit3.Enabled := false;
    Edit3.Color   := clBtnFace;
    Edit3.Text    := '';
    Edit4.Enabled := false;
    Edit4.Color   := clBtnFace;
    Edit4.Text    := '';
  end else begin
    Edit1.Enabled := true;
    Edit1.Color   := clWindow;
    Edit1.Text := AktUser.RealName;
    Edit2.Enabled := true;
    Edit2.Color   := clWindow;
    Edit2.Text := AktUser.UserName;
    Edit3.Enabled := true;
    Edit3.Color   := clWindow;
    Edit3.Text := AktUser.Password;
    Edit4.Enabled := true;
    Edit4.Color   := clWindow;
    Edit4.Text := AktUser.StartDir;
  end;
end;

function TEFTUserSetup.EditUserList: Integer;
var
   i       : Cardinal;
   res     : Integer;
   filevar : File;
begin
  UpdateListbox;
  DisplayAktUser;

  res := ShowModal;

  if (res = mrOk) then begin
    if (UserListe.Count > 0) then begin
      AssignFile (filevar,ExtractFilePath (ParamStr (0)) + 'eftusers.dat');
      Rewrite (filevar, 1);
      if (IOResult = 0) then begin
        for i:=0 to (UserListe.Count - 1) do
          BlockWrite (filevar, TUserDaten (UserListe.Items[i]^), sizeof (TUserDaten));

        CloseFile (filevar);
      end;
    end;
  end;

  EditUserList := res;
end;

procedure TEFTUserSetup.Button1Click(Sender: TObject);
var path : string;
begin
  path := Edit4.Text;

  if (SelectDirectory (path, [sdAllowCreate, sdPerformCreate, sdPrompt], 0)) then
    Edit4.Text := path;
end;

function FormatString (const Zeile : String; const len : Integer) : String;
var line : String;
begin
  line := Zeile;
  while (Length (line) < len) do line := line + ' ';

  FormatString := line;
end;

procedure TEFTUserSetup.UpdateListbox;
var i : Cardinal;
begin
  ListBox1.Clear;

  if (UserListe.Count > 0) then begin
    for i:=0 to (UserListe.Count - 1) do begin
      with TUserDaten (UserListe.Items[i]^) do
        ListBox1.Items.Add (FormatString (RealName,20) + ':' + UserName);
    end;
  end;
end;

procedure TEFTUserSetup.NeuerUser1Click(Sender: TObject);
begin
  AktIndex := UserListe.Count;

  with AktUser do begin
    UserName := '';
    Password := '';
    RealName := '';
    StartDir := '';
  end;

  DisplayAktUser;
end;

procedure TEFTUserSetup.Button3Click(Sender: TObject);
var
  data : PUserDaten;
begin
  AktUser.RealName := Edit1.Text;
  AktUser.UserName := Edit2.Text;
  AktUser.Password := Edit3.Text;
  AktUser.StartDir := Edit4.Text;

  if (AktIndex >= UserListe.Count) then begin
    New (data);
    data^ := AktUser;
    UserListe.Add (data);
  end else begin
    TUserDaten (UserListe.Items[AktIndex]^) := AktUser;
  end;

  UpdateListbox;
end;

procedure TEFTUserSetup.FormCreate(Sender: TObject);
begin
  AktIndex := -1;
end;

procedure TEFTUserSetup.Button2Click(Sender: TObject);
begin
  DisplayAktUser;
  UpdateListbox;
end;

procedure TEFTUserSetup.ListBox1Click(Sender: TObject);
begin
 AktIndex := ListBox1.ItemIndex;
 
 if (AktIndex >= UserListe.Count) then
   AktIndex := -1
 else begin
   if (UserListe.Items[AktIndex] <> Nil) then
     Move (UserListe.Items [AktIndex]^, AktUser, sizeof (TUserDaten))
   else AktIndex := -1;
 end;

 DisplayAktUser;
end;

end.
